/*
 *  Copyright (C) 2024 Texas Instruments Incorporated.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  Name        : cslr_dru.h
 */
#ifndef CSLR_DRU_H_
#define CSLR_DRU_H_

#ifdef __cplusplus
extern "C"
{
#endif
    //#include <ti/csl/cslr.h>
#include <stdint.h>

/**************************************************************************
* Module Base Offset Values
**************************************************************************/

#define CSL_DRU_CBASS_GLB_REGS_BASE                                  (0x00000000U)
#define CSL_DRU_FW_MAIN_FW_REGS_BASE                                 (0x00000000U)
#define CSL_DRU_FW_MAIN_GLB_REGS_BASE                                (0x00000000U)
#define CSL_DRU_CAUSE_REGS_BASE                  (0x000E0000U)
#define CSL_DRU_CHATOMIC_DEBUG_REGS_BASE         (0x00080000U)
#define CSL_DRU_CHCORE_HI_REGS_BASE              (0x000C0000U)
#define CSL_DRU_CHCORE_REGS_BASE                 (0x000A0000U)
#define CSL_DRU_CHNRT_REGS_BASE                  (0x00040000U)
#define CSL_DRU_CHRT_REGS_BASE                   (0x00060000U)
#define CSL_DRU_MEM_ATT0_REGS_BASE               (0x00010000U)
#define CSL_DRU_MEM_ATT1_REGS_BASE               (0x00020000U)
#define CSL_DRU_MEM_ATT2_REGS_BASE               (0x00030000U)
#define CSL_DRU_QUEUE_REGS_BASE                  (0x00008000U)
#define CSL_DRU_REGS_BASE                        (0x00000000U)
#define CSL_DRU_SAFETY_REGS_BASE                 (0x00004000U)


/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t SUBMIT_WORD0_1;            /* The first TR submission word */
    volatile uint64_t SUBMIT_WORD2_3;            /* The second TR submission word */
    volatile uint64_t SUBMIT_WORD4_5;            /* The third TR submission word */
    volatile uint64_t SUBMIT_WORD6_7;            /* The fourth TR submission word */
    volatile uint64_t SUBMIT_WORD8_9;            /* The fifth TR submission word */
    volatile uint64_t SUBMIT_WORD10_11;          /* The sixth TR submission word */
    volatile uint64_t SUBMIT_WORD12_13;          /* The seventh TR submission word */
    volatile uint64_t SUBMIT_WORD14_15;          /* The eight TR submission word */
} CSL_DRU_CHCORERegs_CHCORE_CORE;


typedef struct {
    CSL_DRU_CHCORERegs_CHCORE_CORE CORE[4];
} CSL_DRU_CHCORERegs_CHCORE;


typedef struct {
    CSL_DRU_CHCORERegs_CHCORE CHCORE;
} CSL_DRU_CHCORERegs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_CORE_SUBMIT_WORD0_1(CORE) (0x00000000U+((CORE)*0x40U))
#define CSL_DRU_CORE_SUBMIT_WORD2_3(CORE) (0x00000008U+((CORE)*0x40U))
#define CSL_DRU_CORE_SUBMIT_WORD4_5(CORE) (0x00000010U+((CORE)*0x40U))
#define CSL_DRU_CORE_SUBMIT_WORD6_7(CORE) (0x00000018U+((CORE)*0x40U))
#define CSL_DRU_CORE_SUBMIT_WORD8_9(CORE) (0x00000020U+((CORE)*0x40U))
#define CSL_DRU_CORE_SUBMIT_WORD10_11(CORE) (0x00000028U+((CORE)*0x40U))
#define CSL_DRU_CORE_SUBMIT_WORD12_13(CORE) (0x00000030U+((CORE)*0x40U))
#define CSL_DRU_CORE_SUBMIT_WORD14_15(CORE) (0x00000038U+((CORE)*0x40U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* SUBMIT_WORD0_1 */

#define CSL_DRU_CORE_SUBMIT_WORD0_1_FLAGS_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_FLAGS_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_FLAGS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_FLAGS_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD0_1_ICNT0_MASK (0x0000FFFF00000000U)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_ICNT0_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_ICNT0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_ICNT0_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD0_1_ICNT1_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_ICNT1_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_ICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD0_1_ICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD0_1_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD2_3 */

#define CSL_DRU_CORE_SUBMIT_WORD2_3_RSVD_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD2_3_RSVD_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_SUBMIT_WORD2_3_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD2_3_RSVD_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD2_3_SRC_ADDR_MASK (0x0000FFFFFFFFFFFFU)
#define CSL_DRU_CORE_SUBMIT_WORD2_3_SRC_ADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD2_3_SRC_ADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD2_3_SRC_ADDR_MAX (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD2_3_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD4_5 */

#define CSL_DRU_CORE_SUBMIT_WORD4_5_DIM1_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_DIM1_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_DIM1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_DIM1_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD4_5_ICNT2_MASK (0x0000FFFF00000000U)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_ICNT2_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_ICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_ICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD4_5_ICNT3_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_ICNT3_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_ICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD4_5_ICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD4_5_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD6_7 */

#define CSL_DRU_CORE_SUBMIT_WORD6_7_DIM2_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_SUBMIT_WORD6_7_DIM2_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD6_7_DIM2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD6_7_DIM2_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD6_7_DIM3_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_CORE_SUBMIT_WORD6_7_DIM3_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_SUBMIT_WORD6_7_DIM3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD6_7_DIM3_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD6_7_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD8_9 */

#define CSL_DRU_CORE_SUBMIT_WORD8_9_DDIM1_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_CORE_SUBMIT_WORD8_9_DDIM1_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_SUBMIT_WORD8_9_DDIM1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD8_9_DDIM1_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD8_9_FMTFLAGS_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_SUBMIT_WORD8_9_FMTFLAGS_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD8_9_FMTFLAGS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD8_9_FMTFLAGS_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD8_9_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD10_11 */

#define CSL_DRU_CORE_SUBMIT_WORD10_11_DADDR_MASK (0x0000FFFFFFFFFFFFU)
#define CSL_DRU_CORE_SUBMIT_WORD10_11_DADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD10_11_DADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD10_11_DADDR_MAX (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD10_11_RSVD_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD10_11_RSVD_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_SUBMIT_WORD10_11_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD10_11_RSVD_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD10_11_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD12_13 */

#define CSL_DRU_CORE_SUBMIT_WORD12_13_DDIM2_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_SUBMIT_WORD12_13_DDIM2_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD12_13_DDIM2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD12_13_DDIM2_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD12_13_DDIM3_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_CORE_SUBMIT_WORD12_13_DDIM3_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_SUBMIT_WORD12_13_DDIM3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD12_13_DDIM3_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD12_13_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD14_15 */

#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT0_MASK (0x000000000000FFFFU)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT0_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT0_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT1_MASK (0x00000000FFFF0000U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT1_SHIFT (0x0000000000000010U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT2_MASK (0x0000FFFF00000000U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT2_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT3_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT3_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_SUBMIT_WORD14_15_DICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_SUBMIT_WORD14_15_RESETVAL (0x0000000000000000U)

/**************************************************************************
* Hardware Region  : Mem Attributes for 64k Bytes Region
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint32_t MEMATTR64K[8192];          /* Memory Attributes for 64K regions */
} CSL_DRU_MEM_ATT0Regs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_MEM_ATT0_MEMATTR64K(MEMATTR64K)  (0x00000000U+((MEMATTR64K)*0x4U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* MEMATTR64K */

#define CSL_DRU_MEM_ATT0_MEMATTR64K_INNER_MASK   (0x00000003U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_INNER_SHIFT  (0x00000000U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_INNER_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_INNER_MAX    (0x00000003U)

#define CSL_DRU_MEM_ATT0_MEMATTR64K_OUTER_MASK   (0x0000000CU)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_OUTER_SHIFT  (0x00000002U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_OUTER_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_OUTER_MAX    (0x00000003U)

#define CSL_DRU_MEM_ATT0_MEMATTR64K_SDOMAIN_MASK (0x00000030U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_SDOMAIN_SHIFT (0x00000004U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_SDOMAIN_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_SDOMAIN_MAX  (0x00000003U)

#define CSL_DRU_MEM_ATT0_MEMATTR64K_MEMTYPE_MASK (0x000000C0U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_MEMTYPE_SHIFT (0x00000006U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_MEMTYPE_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT0_MEMATTR64K_MEMTYPE_MAX  (0x00000003U)

#define CSL_DRU_MEM_ATT0_MEMATTR64K_RESETVAL     (0x00000000U)

/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t CFG;                       /* Channel Configuration Register. The Channel Configuration Register is used to initialize static mode settings for the DMA Channel. The register may only be written when the chanel is disable in the ch_enable field in the REALTIME CONTROL register is 0. */
    volatile uint8_t  Resv_32[24];
    volatile uint64_t CHOES0;                    /* The Output Event Steering Registers are used to specify a global event number to generate anytime the required event generation criteria specified in a TR are met. A single event with the event number set equal to the value in the corresponding register will be generated.  This register is provided in order to allow security SW to lock down which events in the global space any given channel/ thread is allowed to generate */
    volatile uint8_t  Resv_96[56];
    volatile uint64_t CHST_SCHED;                /* Channel Static Scheduler Config Register */
    volatile uint8_t  Resv_256[152];
} CSL_DRU_CHNRTRegs_CHNRT;


/* typedef struct { */
/*     CSL_CHNRTRegs_CHNRT CHNRT[512]; */
/* } CSL_CHNRTRegs; */


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_CHNRT_CFG(CHNRT)           (0x00000000U+((CHNRT)*0x100U))
#define CSL_DRU_CHNRT_CHOES0(CHNRT)        (0x00000020U+((CHNRT)*0x100U))
#define CSL_DRU_CHNRT_CHST_SCHED(CHNRT)    (0x00000060U+((CHNRT)*0x100U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* CFG */

#define CSL_DRU_CHNRT_CFG_CHAN_TYPE_MASK   (0x0000000000070000U)
#define CSL_DRU_CHNRT_CFG_CHAN_TYPE_SHIFT  (0x0000000000000010U)
#define CSL_DRU_CHNRT_CFG_CHAN_TYPE_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHNRT_CFG_CHAN_TYPE_MAX    (0x0000000000000007U)

#define CSL_DRU_CHNRT_CFG_CHAN_TYPE_OWNER_MASK (0x0000000000080000U)
#define CSL_DRU_CHNRT_CFG_CHAN_TYPE_OWNER_SHIFT (0x0000000000000013U)
#define CSL_DRU_CHNRT_CFG_CHAN_TYPE_OWNER_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHNRT_CFG_CHAN_TYPE_OWNER_MAX (0x0000000000000001U)

#define CSL_DRU_CHNRT_CFG_PAUSE_ON_ERR_MASK (0x0000000080000000U)
#define CSL_DRU_CHNRT_CFG_PAUSE_ON_ERR_SHIFT (0x000000000000001FU)
#define CSL_DRU_CHNRT_CFG_PAUSE_ON_ERR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHNRT_CFG_PAUSE_ON_ERR_MAX (0x0000000000000001U)

#define CSL_DRU_CHNRT_CFG_RSVD_MASK        (0xFFFFFFFF00000000U)
#define CSL_DRU_CHNRT_CFG_RSVD_SHIFT       (0x0000000000000020U)
#define CSL_DRU_CHNRT_CFG_RSVD_RESETVAL    (0x0000000000000000U)
#define CSL_DRU_CHNRT_CFG_RSVD_MAX         (0x00000000FFFFFFFFU)

#define CSL_DRU_CHNRT_CFG_RESETVAL         (0x0000000000000000U)

/* CHOES0 */

#define CSL_DRU_CHNRT_CHOES0_EVT_NUM_MASK  (0x000000000000FFFFU)
#define CSL_DRU_CHNRT_CHOES0_EVT_NUM_SHIFT (0x0000000000000000U)
#define CSL_DRU_CHNRT_CHOES0_EVT_NUM_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHNRT_CHOES0_EVT_NUM_MAX   (0x000000000000FFFFU)

#define CSL_DRU_CHNRT_CHOES0_RSVD_MASK     (0xFFFFFFFFFFFF0000U)
#define CSL_DRU_CHNRT_CHOES0_RSVD_SHIFT    (0x0000000000000010U)
#define CSL_DRU_CHNRT_CHOES0_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHNRT_CHOES0_RSVD_MAX      (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_CHNRT_CHOES0_RESETVAL      (0x0000000000000000U)

/* CHST_SCHED */

#define CSL_DRU_CHNRT_CHST_SCHED_QUEUE_MASK (0x0000000000000007U)
#define CSL_DRU_CHNRT_CHST_SCHED_QUEUE_SHIFT (0x0000000000000000U)
#define CSL_DRU_CHNRT_CHST_SCHED_QUEUE_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHNRT_CHST_SCHED_QUEUE_MAX (0x0000000000000007U)

#define CSL_DRU_CHNRT_CHST_SCHED_RESETVAL  (0x0000000000000000U)

/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t SUBMIT_WORD0_1;            /* The first TR submission word */
    volatile uint64_t SUBMIT_WORD2_3;            /* The second TR submission word */
    volatile uint64_t SUBMIT_WORD4_5;            /* The third TR submission word */
    volatile uint64_t SUBMIT_WORD6_7;            /* The fourth TR submission word */
    volatile uint64_t SUBMIT_WORD8_9;            /* The fifth TR submission word */
    volatile uint64_t SUBMIT_WORD10_11;          /* The sixth TR submission word */
    volatile uint64_t SUBMIT_WORD12_13;          /* The seventh TR submission word */
    volatile uint64_t SUBMIT_WORD14_15;          /* The eight TR submission word */
} CSL_DRU_CHCORE_HI_CORE_HI;


typedef struct {
    CSL_DRU_CHCORE_HI_CORE_HI CORE_HI[4];
} CSL_DRU_CHCORE_HI;


typedef struct {
    CSL_DRU_CHCORE_HI CHCORE_HI;
} CSL_DRU_CHCORE_HIRegs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1(CORE_HI) (0x00000000U+((CORE_HI)*0x40U))
#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3(CORE_HI) (0x00000008U+((CORE_HI)*0x40U))
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5(CORE_HI) (0x00000010U+((CORE_HI)*0x40U))
#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7(CORE_HI) (0x00000018U+((CORE_HI)*0x40U))
#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9(CORE_HI) (0x00000020U+((CORE_HI)*0x40U))
#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11(CORE_HI) (0x00000028U+((CORE_HI)*0x40U))
#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13(CORE_HI) (0x00000030U+((CORE_HI)*0x40U))
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15(CORE_HI) (0x00000038U+((CORE_HI)*0x40U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* SUBMIT_WORD0_1 */

#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_FLAGS_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_FLAGS_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_FLAGS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_FLAGS_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_ICNT0_MASK (0x0000FFFF00000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_ICNT0_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_ICNT0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_ICNT0_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_ICNT1_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_ICNT1_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_ICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_ICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD0_1_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD2_3 */

#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_RSVD_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_RSVD_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_RSVD_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_SRC_ADDR_MASK (0x0000FFFFFFFFFFFFU)
#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_SRC_ADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_SRC_ADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_SRC_ADDR_MAX (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD2_3_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD4_5 */

#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_DIM1_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_DIM1_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_DIM1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_DIM1_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_ICNT2_MASK (0x0000FFFF00000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_ICNT2_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_ICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_ICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_ICNT3_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_ICNT3_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_ICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_ICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD4_5_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD6_7 */

#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_DIM2_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_DIM2_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_DIM2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_DIM2_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_DIM3_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_DIM3_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_DIM3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_DIM3_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD6_7_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD8_9 */

#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_DDIM1_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_DDIM1_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_DDIM1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_DDIM1_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_FMTFLAGS_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_FMTFLAGS_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_FMTFLAGS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_FMTFLAGS_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD8_9_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD10_11 */

#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_DADDR_MASK (0x0000FFFFFFFFFFFFU)
#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_DADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_DADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_DADDR_MAX (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_RSVD_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_RSVD_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_RSVD_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD10_11_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD12_13 */

#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_DDIM2_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_DDIM2_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_DDIM2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_DDIM2_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_DDIM3_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_DDIM3_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_DDIM3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_DDIM3_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD12_13_RESETVAL (0x0000000000000000U)

/* SUBMIT_WORD14_15 */

#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT0_MASK (0x000000000000FFFFU)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT0_SHIFT (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT0_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT1_MASK (0x00000000FFFF0000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT1_SHIFT (0x0000000000000010U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT2_MASK (0x0000FFFF00000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT2_SHIFT (0x0000000000000020U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT3_MASK (0xFFFF000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT3_SHIFT (0x0000000000000030U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_DICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_CORE_HI_SUBMIT_WORD14_15_RESETVAL (0x0000000000000000U)

/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t DRU_MC_ERR_AR;             /* Address for the correctable error */
    volatile uint64_t DRU_MC_ERR_XR;             /* Correctable Error Status */
    volatile uint64_t DRU_MC_ERR_CLR;            /* Correctable Error Logging Clear */
    volatile uint64_t DRU_MC_ERR_CNT;            /* Correctable Error Count */
    volatile uint64_t DRU_MNC_ERR_AR;            /* Address for the non-correctable error */
    volatile uint64_t DRU_MNC_ERR_XR;            /* Non-Correctable Error Status */
    volatile uint64_t DRU_MNC_ERR_CLR;           /* Non_Correctable Error Logging Clear */
    volatile uint64_t DRU_MNC_ERR_CNT;           /* Non-Correctable Error Count */
    volatile uint64_t DRU_MPERR_CNT;             /* Parity error count */
    volatile uint8_t  Resv_4096[4024];
    volatile uint64_t DRU_MERR_INJ_CTL;          /* Error Injection Control */
} CSL_DRU_SAFETYRegs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_SAFETY_DRU_MC_ERR_AR             (0x00000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR             (0x00000008U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR            (0x00000010U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT            (0x00000018U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_AR            (0x00000020U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR            (0x00000028U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR           (0x00000030U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT           (0x00000038U)
#define CSL_DRU_SAFETY_DRU_MPERR_CNT             (0x00000040U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL          (0x00001000U)

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* DRU_MC_ERR_AR */

#define CSL_DRU_SAFETY_DRU_MC_ERR_AR_ADDR_MASK   (0xFFFFFFFFFFFFFFFFU)
#define CSL_DRU_SAFETY_DRU_MC_ERR_AR_ADDR_SHIFT  (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_AR_ADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_AR_ADDR_MAX    (0xFFFFFFFFFFFFFFFFU)

#define CSL_DRU_SAFETY_DRU_MC_ERR_AR_RESETVAL    (0x0000000000000000U)

/* DRU_MC_ERR_XR */

#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_ID_MASK     (0x00000000FFFFFFFFU)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_ID_SHIFT    (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_ID_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_ID_MAX      (0x00000000FFFFFFFFU)

#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_SYNDROME_MASK (0x000001FF00000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_SYNDROME_SHIFT (0x0000000000000020U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_SYNDROME_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_SYNDROME_MAX (0x00000000000001FFU)

#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_RSVD_MASK   (0xFFFFFE0000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_RSVD_SHIFT  (0x0000000000000029U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_RSVD_MAX    (0x00000000007FFFFFU)

#define CSL_DRU_SAFETY_DRU_MC_ERR_XR_RESETVAL    (0x0000000000000000U)

/* DRU_MC_ERR_CLR */

#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_CLR_MASK   (0x0000000000000001U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_CLR_SHIFT  (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_CLR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_CLR_MAX    (0x0000000000000001U)

#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_RSVD_MASK  (0xFFFFFE0000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_RSVD_SHIFT (0x0000000000000029U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_RSVD_MAX   (0x00000000007FFFFFU)

#define CSL_DRU_SAFETY_DRU_MC_ERR_CLR_RESETVAL   (0x0000000000000000U)

/* DRU_MC_ERR_CNT */

#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_COUNT_MASK (0x00000000000000FFU)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_COUNT_SHIFT (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_COUNT_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_COUNT_MAX  (0x00000000000000FFU)

#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_RSVD_MASK  (0xFFFFFFFFFFFFFF00U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_RSVD_SHIFT (0x0000000000000008U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_RSVD_MAX   (0x00FFFFFFFFFFFFFFU)

#define CSL_DRU_SAFETY_DRU_MC_ERR_CNT_RESETVAL   (0x0000000000000000U)

/* DRU_MNC_ERR_AR */

#define CSL_DRU_SAFETY_DRU_MNC_ERR_AR_ADDR_MASK  (0xFFFFFFFFFFFFFFFFU)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_AR_ADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_AR_ADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_AR_ADDR_MAX   (0xFFFFFFFFFFFFFFFFU)

#define CSL_DRU_SAFETY_DRU_MNC_ERR_AR_RESETVAL   (0x0000000000000000U)

/* DRU_MNC_ERR_XR */

#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_ID_MASK    (0x00000000FFFFFFFFU)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_ID_SHIFT   (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_ID_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_ID_MAX     (0x00000000FFFFFFFFU)

#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_SYNDROME_MASK (0x000001FF00000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_SYNDROME_SHIFT (0x0000000000000020U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_SYNDROME_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_SYNDROME_MAX (0x00000000000001FFU)

#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_RSVD_MASK  (0xFFFFFE0000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_RSVD_SHIFT (0x0000000000000029U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_RSVD_MAX   (0x00000000007FFFFFU)

#define CSL_DRU_SAFETY_DRU_MNC_ERR_XR_RESETVAL   (0x0000000000000000U)

/* DRU_MNC_ERR_CLR */

#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_CLR_MASK  (0x0000000000000001U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_CLR_SHIFT (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_CLR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_CLR_MAX   (0x0000000000000001U)

#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_RSVD_MASK (0xFFFFFE0000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_RSVD_SHIFT (0x0000000000000029U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_RSVD_MAX  (0x00000000007FFFFFU)

#define CSL_DRU_SAFETY_DRU_MNC_ERR_CLR_RESETVAL  (0x0000000000000000U)

/* DRU_MNC_ERR_CNT */

#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_COUNT_MASK (0x00000000000000FFU)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_COUNT_SHIFT (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_COUNT_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_COUNT_MAX (0x00000000000000FFU)

#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_RSVD_MASK (0xFFFFFFFFFFFFFF00U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_RSVD_SHIFT (0x0000000000000008U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_RSVD_MAX  (0x00FFFFFFFFFFFFFFU)

#define CSL_DRU_SAFETY_DRU_MNC_ERR_CNT_RESETVAL  (0x0000000000000000U)

/* DRU_MPERR_CNT */

#define CSL_DRU_SAFETY_DRU_MPERR_CNT_COUNT_MASK  (0x00000000000000FFU)
#define CSL_DRU_SAFETY_DRU_MPERR_CNT_COUNT_SHIFT (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MPERR_CNT_COUNT_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MPERR_CNT_COUNT_MAX   (0x00000000000000FFU)

#define CSL_DRU_SAFETY_DRU_MPERR_CNT_RSVD_MASK   (0xFFFFFFFFFFFFFF00U)
#define CSL_DRU_SAFETY_DRU_MPERR_CNT_RSVD_SHIFT  (0x0000000000000008U)
#define CSL_DRU_SAFETY_DRU_MPERR_CNT_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MPERR_CNT_RSVD_MAX    (0x00FFFFFFFFFFFFFFU)

#define CSL_DRU_SAFETY_DRU_MPERR_CNT_RESETVAL    (0x0000000000000000U)

/* DRU_MERR_INJ_CTL */

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_ID_MASK  (0x00000000FFFFFFFFU)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_ID_SHIFT (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_ID_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_ID_MAX   (0x00000000FFFFFFFFU)

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_BIT1_MASK (0x000001FF00000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_BIT1_SHIFT (0x0000000000000020U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_BIT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_BIT1_MAX (0x00000000000001FFU)

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD0_MASK (0x00000E0000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD0_SHIFT (0x0000000000000029U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD0_MAX (0x0000000000000007U)

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_BIT2_MASK (0x001FF00000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_BIT2_SHIFT (0x000000000000002CU)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_BIT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_BIT2_MAX (0x00000000000001FFU)

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD1_MASK (0x00E0000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD1_SHIFT (0x0000000000000035U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD1_MAX (0x0000000000000007U)

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_PATT_MASK (0x0F00000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_PATT_SHIFT (0x0000000000000038U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_PATT_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_PATT_MAX (0x000000000000000FU)

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD2_MASK (0x3000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD2_SHIFT (0x000000000000003CU)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RSVD2_MAX (0x0000000000000003U)

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_FB1_MASK (0x8000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_FB1_SHIFT (0x000000000000003FU)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_FB1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_FB1_MAX  (0x0000000000000001U)

#define CSL_DRU_SAFETY_DRU_MERR_INJ_CTL_RESETVAL (0x0000000000000000U)

/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t CHRT_CTL;                  /* The channel realtime control register contains real-time cotrol and status information for the DMA Channel. The fields in this regsiter can be changed while the channel is in operation. */
    volatile uint64_t CHRT_SWTRIG;               /* The Software Trigger Register provides a mechanism by which software can directly trigger the channel in a secure way. */
    volatile uint64_t CHRT_STATUS_DET;           /* The channel status details */
    volatile uint8_t  Resv_256[232];
} CSL_DRU_CHRTRegs_CHRT;


/* typedef struct { */
/*     CSL_CHRTRegs_CHRT CHRT[512]; */
/* } CSL_CHRTRegs; */


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_CHRT_CTL(CHRT)         (0x00000000U+((CHRT)*0x100U))
#define CSL_DRU_CHRT_SWTRIG(CHRT)      (0x00000008U+((CHRT)*0x100U))
#define CSL_DRU_CHRT_STATUS_DET(CHRT)  (0x00000010U+((CHRT)*0x100U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* CHRT_CTL */

#define CSL_DRU_CHRT_CTL_ENABLE_MASK   (0x0000000080000000U)
#define CSL_DRU_CHRT_CTL_ENABLE_SHIFT  (0x000000000000001FU)
#define CSL_DRU_CHRT_CTL_ENABLE_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_CTL_ENABLE_MAX    (0x0000000000000001U)

#define CSL_DRU_CHRT_CTL_PAUSE_MASK    (0x0000000020000000U)
#define CSL_DRU_CHRT_CTL_PAUSE_SHIFT   (0x000000000000001DU)
#define CSL_DRU_CHRT_CTL_PAUSE_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_CTL_PAUSE_MAX     (0x0000000000000001U)

#define CSL_DRU_CHRT_CTL_RSVD_MASK     (0xFFFFFFFF00000000U)
#define CSL_DRU_CHRT_CTL_RSVD_SHIFT    (0x0000000000000020U)
#define CSL_DRU_CHRT_CTL_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_CTL_RSVD_MAX      (0x00000000FFFFFFFFU)

#define CSL_DRU_CHRT_CTL_TEARDOWN_MASK (0x0000000040000000U)
#define CSL_DRU_CHRT_CTL_TEARDOWN_SHIFT (0x000000000000001EU)
#define CSL_DRU_CHRT_CTL_TEARDOWN_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_CTL_TEARDOWN_MAX  (0x0000000000000001U)

#define CSL_DRU_CHRT_CTL_RESETVAL      (0x0000000000000000U)

/* CHRT_SWTRIG */

#define CSL_DRU_CHRT_SWTRIG_GLOBAL_TRIGGER0_MASK (0x0000000000000001U)
#define CSL_DRU_CHRT_SWTRIG_GLOBAL_TRIGGER0_SHIFT (0x0000000000000000U)
#define CSL_DRU_CHRT_SWTRIG_GLOBAL_TRIGGER0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_SWTRIG_GLOBAL_TRIGGER0_MAX (0x0000000000000001U)

#define CSL_DRU_CHRT_SWTRIG_GLOBAL_TRIGGER1_MASK (0x0000000000000002U)
#define CSL_DRU_CHRT_SWTRIG_GLOBAL_TRIGGER1_SHIFT (0x0000000000000001U)
#define CSL_DRU_CHRT_SWTRIG_GLOBAL_TRIGGER1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_SWTRIG_GLOBAL_TRIGGER1_MAX (0x0000000000000001U)

#define CSL_DRU_CHRT_SWTRIG_LOCAL_TRIGGER0_MASK (0x0000000000000004U)
#define CSL_DRU_CHRT_SWTRIG_LOCAL_TRIGGER0_SHIFT (0x0000000000000002U)
#define CSL_DRU_CHRT_SWTRIG_LOCAL_TRIGGER0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_SWTRIG_LOCAL_TRIGGER0_MAX (0x0000000000000001U)

#define CSL_DRU_CHRT_SWTRIG_RSVD_MASK  (0xFFFFFFFFFFFFFFF8U)
#define CSL_DRU_CHRT_SWTRIG_RSVD_SHIFT (0x0000000000000003U)
#define CSL_DRU_CHRT_SWTRIG_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_SWTRIG_RSVD_MAX   (0x1FFFFFFFFFFFFFFFU)

#define CSL_DRU_CHRT_SWTRIG_RESETVAL   (0x0000000000000000U)

/* CHRT_STATUS_DET */

#define CSL_DRU_CHRT_STATUS_DET_TYPE_MASK (0x000000000000000FU)
#define CSL_DRU_CHRT_STATUS_DET_TYPE_SHIFT (0x0000000000000000U)
#define CSL_DRU_CHRT_STATUS_DET_TYPE_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_STATUS_DET_TYPE_MAX (0x000000000000000FU)

#define CSL_DRU_CHRT_STATUS_DET_INFO_MASK (0x00000000000000F0U)
#define CSL_DRU_CHRT_STATUS_DET_INFO_SHIFT (0x0000000000000004U)
#define CSL_DRU_CHRT_STATUS_DET_INFO_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_STATUS_DET_INFO_MAX (0x000000000000000FU)

#define CSL_DRU_CHRT_STATUS_DET_CMD_ID_MASK (0x000000000000FF00U)
#define CSL_DRU_CHRT_STATUS_DET_CMD_ID_SHIFT (0x0000000000000008U)
#define CSL_DRU_CHRT_STATUS_DET_CMD_ID_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_STATUS_DET_CMD_ID_MAX (0x00000000000000FFU)

#define CSL_DRU_CHRT_STATUS_DET_ICNT1_MASK (0x000000000000FFFFU)
#define CSL_DRU_CHRT_STATUS_DET_ICNT1_SHIFT (0x0000000000000000U)
#define CSL_DRU_CHRT_STATUS_DET_ICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_STATUS_DET_ICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_CHRT_STATUS_DET_ICNT2_MASK (0x00000000FFFF0000U)
#define CSL_DRU_CHRT_STATUS_DET_ICNT2_SHIFT (0x0000000000000010U)
#define CSL_DRU_CHRT_STATUS_DET_ICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_STATUS_DET_ICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_CHRT_STATUS_DET_ICNT3_MASK (0x0000FFFF00000000U)
#define CSL_DRU_CHRT_STATUS_DET_ICNT3_SHIFT (0x0000000000000020U)
#define CSL_DRU_CHRT_STATUS_DET_ICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CHRT_STATUS_DET_ICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_CHRT_STATUS_DET_RESETVAL (0x0000000000000000U)

/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t CAUSE[32];
} CSL_DRU_CAUSE;


typedef struct {
    CSL_DRU_CAUSE CAUSE;
} CSL_DRU_CAUSERegs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_CAUSE(CAUSE)         (0x00000000U+((CAUSE)*0x8U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* CAUSE */

#define CSL_DRU_CAUSE_R_ERR15_MASK   (0x8000000000000000U)
#define CSL_DRU_CAUSE_R_ERR15_SHIFT  (0x000000000000003FU)
#define CSL_DRU_CAUSE_R_ERR15_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR15_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND15_MASK  (0x4000000000000000U)
#define CSL_DRU_CAUSE_R_PEND15_SHIFT (0x000000000000003EU)
#define CSL_DRU_CAUSE_R_PEND15_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND15_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR15_MASK   (0x2000000000000000U)
#define CSL_DRU_CAUSE_T_ERR15_SHIFT  (0x000000000000003DU)
#define CSL_DRU_CAUSE_T_ERR15_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR15_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND15_MASK  (0x1000000000000000U)
#define CSL_DRU_CAUSE_T_PEND15_SHIFT (0x000000000000003CU)
#define CSL_DRU_CAUSE_T_PEND15_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND15_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR14_MASK   (0x0800000000000000U)
#define CSL_DRU_CAUSE_R_ERR14_SHIFT  (0x000000000000003BU)
#define CSL_DRU_CAUSE_R_ERR14_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR14_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND14_MASK  (0x0400000000000000U)
#define CSL_DRU_CAUSE_R_PEND14_SHIFT (0x000000000000003AU)
#define CSL_DRU_CAUSE_R_PEND14_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND14_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR14_MASK   (0x0200000000000000U)
#define CSL_DRU_CAUSE_T_ERR14_SHIFT  (0x0000000000000039U)
#define CSL_DRU_CAUSE_T_ERR14_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR14_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND14_MASK  (0x0100000000000000U)
#define CSL_DRU_CAUSE_T_PEND14_SHIFT (0x0000000000000038U)
#define CSL_DRU_CAUSE_T_PEND14_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND14_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR13_MASK   (0x0080000000000000U)
#define CSL_DRU_CAUSE_R_ERR13_SHIFT  (0x0000000000000037U)
#define CSL_DRU_CAUSE_R_ERR13_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR13_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND13_MASK  (0x0040000000000000U)
#define CSL_DRU_CAUSE_R_PEND13_SHIFT (0x0000000000000036U)
#define CSL_DRU_CAUSE_R_PEND13_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND13_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR13_MASK   (0x0020000000000000U)
#define CSL_DRU_CAUSE_T_ERR13_SHIFT  (0x0000000000000035U)
#define CSL_DRU_CAUSE_T_ERR13_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR13_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND13_MASK  (0x0010000000000000U)
#define CSL_DRU_CAUSE_T_PEND13_SHIFT (0x0000000000000034U)
#define CSL_DRU_CAUSE_T_PEND13_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND13_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR12_MASK   (0x0008000000000000U)
#define CSL_DRU_CAUSE_R_ERR12_SHIFT  (0x0000000000000033U)
#define CSL_DRU_CAUSE_R_ERR12_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR12_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND12_MASK  (0x0004000000000000U)
#define CSL_DRU_CAUSE_R_PEND12_SHIFT (0x0000000000000032U)
#define CSL_DRU_CAUSE_R_PEND12_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND12_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR12_MASK   (0x0002000000000000U)
#define CSL_DRU_CAUSE_T_ERR12_SHIFT  (0x0000000000000031U)
#define CSL_DRU_CAUSE_T_ERR12_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR12_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND12_MASK  (0x0001000000000000U)
#define CSL_DRU_CAUSE_T_PEND12_SHIFT (0x0000000000000030U)
#define CSL_DRU_CAUSE_T_PEND12_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND12_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR11_MASK   (0x0000800000000000U)
#define CSL_DRU_CAUSE_R_ERR11_SHIFT  (0x000000000000002FU)
#define CSL_DRU_CAUSE_R_ERR11_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR11_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND11_MASK  (0x0000400000000000U)
#define CSL_DRU_CAUSE_R_PEND11_SHIFT (0x000000000000002EU)
#define CSL_DRU_CAUSE_R_PEND11_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND11_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR11_MASK   (0x0000200000000000U)
#define CSL_DRU_CAUSE_T_ERR11_SHIFT  (0x000000000000002DU)
#define CSL_DRU_CAUSE_T_ERR11_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR11_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND11_MASK  (0x0000100000000000U)
#define CSL_DRU_CAUSE_T_PEND11_SHIFT (0x000000000000002CU)
#define CSL_DRU_CAUSE_T_PEND11_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND11_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR10_MASK   (0x0000080000000000U)
#define CSL_DRU_CAUSE_R_ERR10_SHIFT  (0x000000000000002BU)
#define CSL_DRU_CAUSE_R_ERR10_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR10_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND10_MASK  (0x0000040000000000U)
#define CSL_DRU_CAUSE_R_PEND10_SHIFT (0x000000000000002AU)
#define CSL_DRU_CAUSE_R_PEND10_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND10_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR10_MASK   (0x0000020000000000U)
#define CSL_DRU_CAUSE_T_ERR10_SHIFT  (0x0000000000000029U)
#define CSL_DRU_CAUSE_T_ERR10_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR10_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND10_MASK  (0x0000010000000000U)
#define CSL_DRU_CAUSE_T_PEND10_SHIFT (0x0000000000000028U)
#define CSL_DRU_CAUSE_T_PEND10_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND10_MAX   (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR9_MASK    (0x0000008000000000U)
#define CSL_DRU_CAUSE_R_ERR9_SHIFT   (0x0000000000000027U)
#define CSL_DRU_CAUSE_R_ERR9_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR9_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND9_MASK   (0x0000004000000000U)
#define CSL_DRU_CAUSE_R_PEND9_SHIFT  (0x0000000000000026U)
#define CSL_DRU_CAUSE_R_PEND9_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND9_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR9_MASK    (0x0000002000000000U)
#define CSL_DRU_CAUSE_T_ERR9_SHIFT   (0x0000000000000025U)
#define CSL_DRU_CAUSE_T_ERR9_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR9_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND9_MASK   (0x0000001000000000U)
#define CSL_DRU_CAUSE_T_PEND9_SHIFT  (0x0000000000000024U)
#define CSL_DRU_CAUSE_T_PEND9_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND9_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR8_MASK    (0x0000000800000000U)
#define CSL_DRU_CAUSE_R_ERR8_SHIFT   (0x0000000000000023U)
#define CSL_DRU_CAUSE_R_ERR8_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR8_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND8_MASK   (0x0000000400000000U)
#define CSL_DRU_CAUSE_R_PEND8_SHIFT  (0x0000000000000022U)
#define CSL_DRU_CAUSE_R_PEND8_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND8_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR8_MASK    (0x0000000200000000U)
#define CSL_DRU_CAUSE_T_ERR8_SHIFT   (0x0000000000000021U)
#define CSL_DRU_CAUSE_T_ERR8_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR8_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND8_MASK   (0x0000000100000000U)
#define CSL_DRU_CAUSE_T_PEND8_SHIFT  (0x0000000000000020U)
#define CSL_DRU_CAUSE_T_PEND8_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND8_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR7_MASK    (0x0000000080000000U)
#define CSL_DRU_CAUSE_R_ERR7_SHIFT   (0x000000000000001FU)
#define CSL_DRU_CAUSE_R_ERR7_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR7_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND7_MASK   (0x0000000040000000U)
#define CSL_DRU_CAUSE_R_PEND7_SHIFT  (0x000000000000001EU)
#define CSL_DRU_CAUSE_R_PEND7_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND7_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR7_MASK    (0x0000000020000000U)
#define CSL_DRU_CAUSE_T_ERR7_SHIFT   (0x000000000000001DU)
#define CSL_DRU_CAUSE_T_ERR7_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR7_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND7_MASK   (0x0000000010000000U)
#define CSL_DRU_CAUSE_T_PEND7_SHIFT  (0x000000000000001CU)
#define CSL_DRU_CAUSE_T_PEND7_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND7_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR6_MASK    (0x0000000008000000U)
#define CSL_DRU_CAUSE_R_ERR6_SHIFT   (0x000000000000001BU)
#define CSL_DRU_CAUSE_R_ERR6_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR6_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND6_MASK   (0x0000000004000000U)
#define CSL_DRU_CAUSE_R_PEND6_SHIFT  (0x000000000000001AU)
#define CSL_DRU_CAUSE_R_PEND6_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND6_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR6_MASK    (0x0000000002000000U)
#define CSL_DRU_CAUSE_T_ERR6_SHIFT   (0x0000000000000019U)
#define CSL_DRU_CAUSE_T_ERR6_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR6_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND6_MASK   (0x0000000001000000U)
#define CSL_DRU_CAUSE_T_PEND6_SHIFT  (0x0000000000000018U)
#define CSL_DRU_CAUSE_T_PEND6_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND6_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR5_MASK    (0x0000000000800000U)
#define CSL_DRU_CAUSE_R_ERR5_SHIFT   (0x0000000000000017U)
#define CSL_DRU_CAUSE_R_ERR5_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR5_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND5_MASK   (0x0000000000400000U)
#define CSL_DRU_CAUSE_R_PEND5_SHIFT  (0x0000000000000016U)
#define CSL_DRU_CAUSE_R_PEND5_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND5_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR5_MASK    (0x0000000000200000U)
#define CSL_DRU_CAUSE_T_ERR5_SHIFT   (0x0000000000000015U)
#define CSL_DRU_CAUSE_T_ERR5_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR5_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND5_MASK   (0x0000000000100000U)
#define CSL_DRU_CAUSE_T_PEND5_SHIFT  (0x0000000000000014U)
#define CSL_DRU_CAUSE_T_PEND5_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND5_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR4_MASK    (0x0000000000080000U)
#define CSL_DRU_CAUSE_R_ERR4_SHIFT   (0x0000000000000013U)
#define CSL_DRU_CAUSE_R_ERR4_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR4_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND4_MASK   (0x0000000000040000U)
#define CSL_DRU_CAUSE_R_PEND4_SHIFT  (0x0000000000000012U)
#define CSL_DRU_CAUSE_R_PEND4_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND4_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR4_MASK    (0x0000000000020000U)
#define CSL_DRU_CAUSE_T_ERR4_SHIFT   (0x0000000000000011U)
#define CSL_DRU_CAUSE_T_ERR4_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR4_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND4_MASK   (0x0000000000010000U)
#define CSL_DRU_CAUSE_T_PEND4_SHIFT  (0x0000000000000010U)
#define CSL_DRU_CAUSE_T_PEND4_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND4_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR3_MASK    (0x0000000000008000U)
#define CSL_DRU_CAUSE_R_ERR3_SHIFT   (0x000000000000000FU)
#define CSL_DRU_CAUSE_R_ERR3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR3_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND3_MASK   (0x0000000000004000U)
#define CSL_DRU_CAUSE_R_PEND3_SHIFT  (0x000000000000000EU)
#define CSL_DRU_CAUSE_R_PEND3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND3_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR3_MASK    (0x0000000000002000U)
#define CSL_DRU_CAUSE_T_ERR3_SHIFT   (0x000000000000000DU)
#define CSL_DRU_CAUSE_T_ERR3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR3_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND3_MASK   (0x0000000000001000U)
#define CSL_DRU_CAUSE_T_PEND3_SHIFT  (0x000000000000000CU)
#define CSL_DRU_CAUSE_T_PEND3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND3_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR2_MASK    (0x0000000000000800U)
#define CSL_DRU_CAUSE_R_ERR2_SHIFT   (0x000000000000000BU)
#define CSL_DRU_CAUSE_R_ERR2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR2_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND2_MASK   (0x0000000000000400U)
#define CSL_DRU_CAUSE_R_PEND2_SHIFT  (0x000000000000000AU)
#define CSL_DRU_CAUSE_R_PEND2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND2_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR2_MASK    (0x0000000000000200U)
#define CSL_DRU_CAUSE_T_ERR2_SHIFT   (0x0000000000000009U)
#define CSL_DRU_CAUSE_T_ERR2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR2_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND2_MASK   (0x0000000000000100U)
#define CSL_DRU_CAUSE_T_PEND2_SHIFT  (0x0000000000000008U)
#define CSL_DRU_CAUSE_T_PEND2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND2_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR1_MASK    (0x0000000000000080U)
#define CSL_DRU_CAUSE_R_ERR1_SHIFT   (0x0000000000000007U)
#define CSL_DRU_CAUSE_R_ERR1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR1_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND1_MASK   (0x0000000000000040U)
#define CSL_DRU_CAUSE_R_PEND1_SHIFT  (0x0000000000000006U)
#define CSL_DRU_CAUSE_R_PEND1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND1_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR1_MASK    (0x0000000000000020U)
#define CSL_DRU_CAUSE_T_ERR1_SHIFT   (0x0000000000000005U)
#define CSL_DRU_CAUSE_T_ERR1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR1_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND1_MASK   (0x0000000000000010U)
#define CSL_DRU_CAUSE_T_PEND1_SHIFT  (0x0000000000000004U)
#define CSL_DRU_CAUSE_T_PEND1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND1_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_ERR0_MASK    (0x0000000000000008U)
#define CSL_DRU_CAUSE_R_ERR0_SHIFT   (0x0000000000000003U)
#define CSL_DRU_CAUSE_R_ERR0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_ERR0_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_R_PEND0_MASK   (0x0000000000000004U)
#define CSL_DRU_CAUSE_R_PEND0_SHIFT  (0x0000000000000002U)
#define CSL_DRU_CAUSE_R_PEND0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_R_PEND0_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_ERR0_MASK    (0x0000000000000002U)
#define CSL_DRU_CAUSE_T_ERR0_SHIFT   (0x0000000000000001U)
#define CSL_DRU_CAUSE_T_ERR0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_ERR0_MAX     (0x0000000000000001U)

#define CSL_DRU_CAUSE_T_PEND0_MASK   (0x0000000000000001U)
#define CSL_DRU_CAUSE_T_PEND0_SHIFT  (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAUSE_T_PEND0_MAX    (0x0000000000000001U)

#define CSL_DRU_CAUSE_RESETVAL       (0x0000000000000000U)

/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t CFG[8];                    /* Configuration Register for Queue 0 */
    volatile uint64_t STATUS[8];                 /* Status Register for Queue 0 */
} CSL_DRU_QUEUERegs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_QUEUE_CFG(CFG)                   (0x00000000U+((CFG)*0x8U))
#define CSL_DRU_QUEUE_STATUS(STATUS)             (0x00000040U+((STATUS)*0x8U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* CFG */

#define CSL_DRU_QUEUE_CFG_CONSECUTIVE_TRANS_MASK (0x0000000000FF0000U)
#define CSL_DRU_QUEUE_CFG_CONSECUTIVE_TRANS_SHIFT (0x0000000000000010U)
#define CSL_DRU_QUEUE_CFG_CONSECUTIVE_TRANS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_QUEUE_CFG_CONSECUTIVE_TRANS_MAX  (0x00000000000000FFU)

#define CSL_DRU_QUEUE_CFG_ORDERID_MASK           (0x00000000000000F0U)
#define CSL_DRU_QUEUE_CFG_ORDERID_SHIFT          (0x0000000000000004U)
#define CSL_DRU_QUEUE_CFG_ORDERID_RESETVAL       (0x0000000000000000U)
#define CSL_DRU_QUEUE_CFG_ORDERID_MAX            (0x000000000000000FU)

#define CSL_DRU_QUEUE_CFG_PRI_MASK               (0x0000000000000007U)
#define CSL_DRU_QUEUE_CFG_PRI_SHIFT              (0x0000000000000000U)
#define CSL_DRU_QUEUE_CFG_PRI_RESETVAL           (0x0000000000000000U)
#define CSL_DRU_QUEUE_CFG_PRI_MAX                (0x0000000000000007U)

#define CSL_DRU_QUEUE_CFG_QOS_MASK               (0x0000000000000700U)
#define CSL_DRU_QUEUE_CFG_QOS_SHIFT              (0x0000000000000008U)
#define CSL_DRU_QUEUE_CFG_QOS_RESETVAL           (0x0000000000000000U)
#define CSL_DRU_QUEUE_CFG_QOS_MAX                (0x0000000000000007U)

#define CSL_DRU_QUEUE_CFG_REARB_WAIT_MASK        (0x00000000FF000000U)
#define CSL_DRU_QUEUE_CFG_REARB_WAIT_SHIFT       (0x0000000000000018U)
#define CSL_DRU_QUEUE_CFG_REARB_WAIT_RESETVAL    (0x0000000000000000U)
#define CSL_DRU_QUEUE_CFG_REARB_WAIT_MAX         (0x00000000000000FFU)

#define CSL_DRU_QUEUE_CFG_RSVD_MASK              (0xFFFFFFFF00000000U)
#define CSL_DRU_QUEUE_CFG_RSVD_SHIFT             (0x0000000000000020U)
#define CSL_DRU_QUEUE_CFG_RSVD_RESETVAL          (0x0000000000000000U)
#define CSL_DRU_QUEUE_CFG_RSVD_MAX               (0x00000000FFFFFFFFU)

#define CSL_DRU_QUEUE_CFG_RESETVAL               (0x0000000000000000U)

/* STATUS */

#define CSL_DRU_QUEUE_STATUS_RD_TOP_MASK         (0x0000000007FC0000U)
#define CSL_DRU_QUEUE_STATUS_RD_TOP_SHIFT        (0x0000000000000012U)
#define CSL_DRU_QUEUE_STATUS_RD_TOP_RESETVAL     (0x0000000000000000U)
#define CSL_DRU_QUEUE_STATUS_RD_TOP_MAX          (0x00000000000001FFU)

#define CSL_DRU_QUEUE_STATUS_RD_TOTAL_MASK       (0x0000000FF8000000U)
#define CSL_DRU_QUEUE_STATUS_RD_TOTAL_SHIFT      (0x000000000000001BU)
#define CSL_DRU_QUEUE_STATUS_RD_TOTAL_RESETVAL   (0x0000000000000000U)
#define CSL_DRU_QUEUE_STATUS_RD_TOTAL_MAX        (0x00000000000001FFU)

#define CSL_DRU_QUEUE_STATUS_RSVD_MASK           (0xFFFFFFF000000000U)
#define CSL_DRU_QUEUE_STATUS_RSVD_SHIFT          (0x0000000000000024U)
#define CSL_DRU_QUEUE_STATUS_RSVD_RESETVAL       (0x0000000000000000U)
#define CSL_DRU_QUEUE_STATUS_RSVD_MAX            (0x000000000FFFFFFFU)

#define CSL_DRU_QUEUE_STATUS_WR_TOP_MASK         (0x00000000000001FFU)
#define CSL_DRU_QUEUE_STATUS_WR_TOP_SHIFT        (0x0000000000000000U)
#define CSL_DRU_QUEUE_STATUS_WR_TOP_RESETVAL     (0x0000000000000000U)
#define CSL_DRU_QUEUE_STATUS_WR_TOP_MAX          (0x00000000000001FFU)

#define CSL_DRU_QUEUE_STATUS_WR_TOTAL_MASK       (0x000000000003FE00U)
#define CSL_DRU_QUEUE_STATUS_WR_TOTAL_SHIFT      (0x0000000000000009U)
#define CSL_DRU_QUEUE_STATUS_WR_TOTAL_RESETVAL   (0x0000000000000000U)
#define CSL_DRU_QUEUE_STATUS_WR_TOTAL_MAX        (0x00000000000001FFU)

#define CSL_DRU_QUEUE_STATUS_RESETVAL            (0x0000000000000000U)

/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t DRU_PID;                   /* Peripheral ID Register */
    volatile uint64_t DRU_CAPABILITIES;          /* DRU Capabilities: Lists the capabilities of the channel for TR TYPE and formatting functions */
} CSL_DRU_Regs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_PID                          (0x00000000U)
#define CSL_DRU_CAPABILITIES                 (0x00000008U)

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* DRU_PID */

#define CSL_DRU_PID_REVISION_MASK            (0x00000000FFFFFFFFU)
#define CSL_DRU_PID_REVISION_SHIFT           (0x0000000000000000U)
#define CSL_DRU_PID_REVISION_RESETVAL        (0x00000000662C0900U)
#define CSL_DRU_PID_REVISION_MAX             (0x00000000FFFFFFFFU)

#define CSL_DRU_PID_RSVD_MASK                (0xFFFFFFFF00000000U)
#define CSL_DRU_PID_RSVD_SHIFT               (0x0000000000000020U)
#define CSL_DRU_PID_RSVD_RESETVAL            (0x0000000000000000U)
#define CSL_DRU_PID_RSVD_MAX                 (0x00000000FFFFFFFFU)

#define CSL_DRU_PID_RESETVAL                 (0x00000000662C0900U)

/* DRU_CAPABILITIES */

#define CSL_DRU_CAPABILITIES_TYPE0_MASK      (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_TYPE0_SHIFT     (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE0_RESETVAL  (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE0_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE1_MASK      (0x0000000000000002U)
#define CSL_DRU_CAPABILITIES_TYPE1_SHIFT     (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_TYPE1_RESETVAL  (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE1_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE2_MASK      (0x0000000000000004U)
#define CSL_DRU_CAPABILITIES_TYPE2_SHIFT     (0x0000000000000002U)
#define CSL_DRU_CAPABILITIES_TYPE2_RESETVAL  (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE2_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE3_MASK      (0x0000000000000008U)
#define CSL_DRU_CAPABILITIES_TYPE3_SHIFT     (0x0000000000000003U)
#define CSL_DRU_CAPABILITIES_TYPE3_RESETVAL  (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE3_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE4_MASK      (0x0000000000000010U)
#define CSL_DRU_CAPABILITIES_TYPE4_SHIFT     (0x0000000000000004U)
#define CSL_DRU_CAPABILITIES_TYPE4_RESETVAL  (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE4_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE5_MASK      (0x0000000000000020U)
#define CSL_DRU_CAPABILITIES_TYPE5_SHIFT     (0x0000000000000005U)
#define CSL_DRU_CAPABILITIES_TYPE5_RESETVAL  (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_TYPE5_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE6_MASK      (0x0000000000000040U)
#define CSL_DRU_CAPABILITIES_TYPE6_SHIFT     (0x0000000000000006U)
#define CSL_DRU_CAPABILITIES_TYPE6_RESETVAL  (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE6_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE7_MASK      (0x0000000000000080U)
#define CSL_DRU_CAPABILITIES_TYPE7_SHIFT     (0x0000000000000007U)
#define CSL_DRU_CAPABILITIES_TYPE7_RESETVAL  (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE7_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE8_MASK      (0x0000000000000100U)
#define CSL_DRU_CAPABILITIES_TYPE8_SHIFT     (0x0000000000000008U)
#define CSL_DRU_CAPABILITIES_TYPE8_RESETVAL  (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_TYPE8_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE9_MASK      (0x0000000000000200U)
#define CSL_DRU_CAPABILITIES_TYPE9_SHIFT     (0x0000000000000009U)
#define CSL_DRU_CAPABILITIES_TYPE9_RESETVAL  (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE9_MAX       (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE10_MASK     (0x0000000000000400U)
#define CSL_DRU_CAPABILITIES_TYPE10_SHIFT    (0x000000000000000AU)
#define CSL_DRU_CAPABILITIES_TYPE10_RESETVAL (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_TYPE10_MAX      (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE11_MASK     (0x0000000000000800U)
#define CSL_DRU_CAPABILITIES_TYPE11_SHIFT    (0x000000000000000BU)
#define CSL_DRU_CAPABILITIES_TYPE11_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE11_MAX      (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE12_MASK     (0x0000000000001000U)
#define CSL_DRU_CAPABILITIES_TYPE12_SHIFT    (0x000000000000000CU)
#define CSL_DRU_CAPABILITIES_TYPE12_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE12_MAX      (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE13_MASK     (0x0000000000002000U)
#define CSL_DRU_CAPABILITIES_TYPE13_SHIFT    (0x000000000000000DU)
#define CSL_DRU_CAPABILITIES_TYPE13_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE13_MAX      (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE14_MASK     (0x0000000000004000U)
#define CSL_DRU_CAPABILITIES_TYPE14_SHIFT    (0x000000000000000EU)
#define CSL_DRU_CAPABILITIES_TYPE14_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE14_MAX      (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TYPE15_MASK     (0x0000000000008000U)
#define CSL_DRU_CAPABILITIES_TYPE15_SHIFT    (0x000000000000000FU)
#define CSL_DRU_CAPABILITIES_TYPE15_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_TYPE15_MAX      (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_TRSTATIC_MASK   (0x0000000000010000U)
#define CSL_DRU_CAPABILITIES_TRSTATIC_SHIFT  (0x0000000000000010U)
#define CSL_DRU_CAPABILITIES_TRSTATIC_RESETVAL (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_TRSTATIC_MAX    (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_EOL_MASK        (0x0000000000020000U)
#define CSL_DRU_CAPABILITIES_EOL_SHIFT       (0x0000000000000011U)
#define CSL_DRU_CAPABILITIES_EOL_RESETVAL    (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_EOL_MAX         (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_LOCAL_TRIG_MASK (0x0000000000040000U)
#define CSL_DRU_CAPABILITIES_LOCAL_TRIG_SHIFT (0x0000000000000012U)
#define CSL_DRU_CAPABILITIES_LOCAL_TRIG_RESETVAL (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_LOCAL_TRIG_MAX  (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_GLOBAL_TRIG_MASK (0x0000000000080000U)
#define CSL_DRU_CAPABILITIES_GLOBAL_TRIG_SHIFT (0x0000000000000013U)
#define CSL_DRU_CAPABILITIES_GLOBAL_TRIG_RESETVAL (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_GLOBAL_TRIG_MAX (0x0000000000000001U)

#define CSL_DRU_CAPABILITIES_RSVD_CONF_SPEC_MASK (0x00000000FFF00000U)
#define CSL_DRU_CAPABILITIES_RSVD_CONF_SPEC_SHIFT (0x0000000000000014U)
#define CSL_DRU_CAPABILITIES_RSVD_CONF_SPEC_RESETVAL (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_RSVD_CONF_SPEC_MAX (0x0000000000000FFFU)

#define CSL_DRU_CAPABILITIES_AMODE_MASK      (0x0000000700000000U)
#define CSL_DRU_CAPABILITIES_AMODE_SHIFT     (0x0000000000000020U)
#define CSL_DRU_CAPABILITIES_AMODE_RESETVAL  (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_AMODE_MAX       (0x0000000000000007U)

#define CSL_DRU_CAPABILITIES_ELTYPE_MASK     (0x0000007800000000U)
#define CSL_DRU_CAPABILITIES_ELTYPE_SHIFT    (0x0000000000000023U)
#define CSL_DRU_CAPABILITIES_ELTYPE_RESETVAL (0x000000000000000BU)
#define CSL_DRU_CAPABILITIES_ELTYPE_MAX      (0x000000000000000FU)

#define CSL_DRU_CAPABILITIES_DFMT_MASK       (0x0000038000000000U)
#define CSL_DRU_CAPABILITIES_DFMT_SHIFT      (0x0000000000000027U)
#define CSL_DRU_CAPABILITIES_DFMT_RESETVAL   (0x0000000000000003U)
#define CSL_DRU_CAPABILITIES_DFMT_MAX        (0x0000000000000007U)

#define CSL_DRU_CAPABILITIES_SECTR_MASK      (0x00003C0000000000U)
#define CSL_DRU_CAPABILITIES_SECTR_SHIFT     (0x000000000000002AU)
#define CSL_DRU_CAPABILITIES_SECTR_RESETVAL  (0x0000000000000001U)
#define CSL_DRU_CAPABILITIES_SECTR_MAX       (0x000000000000000FU)

#define CSL_DRU_CAPABILITIES_RSVD_MASK       (0xFFFFC00000000000U)
#define CSL_DRU_CAPABILITIES_RSVD_SHIFT      (0x000000000000002EU)
#define CSL_DRU_CAPABILITIES_RSVD_RESETVAL   (0x0000000000000000U)
#define CSL_DRU_CAPABILITIES_RSVD_MAX        (0x000000000003FFFFU)

#define CSL_DRU_CAPABILITIES_RESETVAL        (0x000005D9000D0520U)

/**************************************************************************
* Hardware Region  : Mem Attributes for first 16M Bytes Region
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint32_t MEMATTR16M0[8192];         /* Memory Attributes for first 16M regions */
} CSL_DRU_MEM_ATT1Regs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_MEM_ATT1_MEMATTR16M0(MEMATTR16M0) (0x00000000U+((MEMATTR16M0)*0x4U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* MEMATTR16M0 */

#define CSL_DRU_MEM_ATT1_MEMATTR16M0_INNER_MASK  (0x00000003U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_INNER_SHIFT (0x00000000U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_INNER_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_INNER_MAX   (0x00000003U)

#define CSL_DRU_MEM_ATT1_MEMATTR16M0_OUTER_MASK  (0x0000000CU)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_OUTER_SHIFT (0x00000002U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_OUTER_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_OUTER_MAX   (0x00000003U)

#define CSL_DRU_MEM_ATT1_MEMATTR16M0_SDOMAIN_MASK (0x00000030U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_SDOMAIN_SHIFT (0x00000004U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_SDOMAIN_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_SDOMAIN_MAX (0x00000003U)

#define CSL_DRU_MEM_ATT1_MEMATTR16M0_MEMTYPE_MASK (0x000000C0U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_MEMTYPE_SHIFT (0x00000006U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_MEMTYPE_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT1_MEMATTR16M0_MEMTYPE_MAX (0x00000003U)

#define CSL_DRU_MEM_ATT1_MEMATTR16M0_RESETVAL    (0x00000000U)

/**************************************************************************
* Hardware Region  : Mem Attributes for second 16M Bytes Region
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint32_t MEMATTR16M1[8192];         /* Memory Attributes for second 16M regions */
} CSL_DRU_MEM_ATT2Regs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_MEM_ATT2_MEMATTR16M1(MEMATTR16M1) (0x00000000U+((MEMATTR16M1)*0x4U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* MEMATTR16M1 */

#define CSL_DRU_MEM_ATT2_MEMATTR16M1_INNER_MASK  (0x00000003U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_INNER_SHIFT (0x00000000U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_INNER_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_INNER_MAX   (0x00000003U)

#define CSL_DRU_MEM_ATT2_MEMATTR16M1_OUTER_MASK  (0x0000000CU)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_OUTER_SHIFT (0x00000002U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_OUTER_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_OUTER_MAX   (0x00000003U)

#define CSL_DRU_MEM_ATT2_MEMATTR16M1_SDOMAIN_MASK (0x00000030U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_SDOMAIN_SHIFT (0x00000004U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_SDOMAIN_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_SDOMAIN_MAX (0x00000003U)

#define CSL_DRU_MEM_ATT2_MEMATTR16M1_MEMTYPE_MASK (0x000000C0U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_MEMTYPE_SHIFT (0x00000006U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_MEMTYPE_RESETVAL (0x00000000U)
#define CSL_DRU_MEM_ATT2_MEMATTR16M1_MEMTYPE_MAX (0x00000003U)

#define CSL_DRU_MEM_ATT2_MEMATTR16M1_RESETVAL    (0x00000000U)

/**************************************************************************
* Hardware Region  :
**************************************************************************/


/**************************************************************************
* Register Overlay Structure
**************************************************************************/


typedef struct {
    volatile uint64_t NEXT_TR_WORD0_1;           /* The first TR submission word */
    volatile uint64_t NEXT_TR_WORD2_3;           /* The second TR submission word */
    volatile uint64_t NEXT_TR_WORD4_5;           /* The third TR submission word */
    volatile uint64_t NEXT_TR_WORD6_7;           /* The fourth TR submission word */
    volatile uint64_t NEXT_TR_WORD8_9;           /* The fifth TR submission word */
    volatile uint64_t NEXT_TR_WORD10_11;         /* The sixth TR submission word */
    volatile uint64_t NEXT_TR_WORD12_13;         /* The seventh TR submission word */
    volatile uint64_t NEXT_TR_WORD14_15;         /* The eight TR submission word */
} CSL_DRU_CHATOMIC_DEBUGRegs_CHATOMIC_DEBUG_DEBUG;


typedef struct {
    volatile uint64_t ATOMIC_SUBMIT_CURR_TR_WORD0_1;   /* The first TR submission word */
    volatile uint64_t ATOMIC_SUBMIT_CURR_TR_WORD2_3;   /* The second TR submission word */
    volatile uint64_t ATOMIC_SUBMIT_CURR_TR_WORD4_5;   /* The third TR submission word */
    volatile uint64_t ATOMIC_SUBMIT_CURR_TR_WORD6_7;   /* The fourth TR submission word */
    volatile uint64_t ATOMIC_SUBMIT_CURR_TR_WORD8_9;   /* The fifth TR submission word */
    volatile uint64_t ATOMIC_SUBMIT_CURR_TR_WORD10_11;   /* The sixth TR submission word */
    volatile uint64_t ATOMIC_SUBMIT_CURR_TR_WORD12_13;   /* The seventh TR submission word */
    volatile uint64_t ATOMIC_SUBMIT_CURR_TR_WORD14_15;   /* The eight TR submission word */
    CSL_DRU_CHATOMIC_DEBUGRegs_CHATOMIC_DEBUG_DEBUG DEBUG[3];
} CSL_DRU_CHATOMIC_DEBUGRegs_CHATOMIC_DEBUG;


typedef struct {
    CSL_DRU_CHATOMIC_DEBUGRegs_CHATOMIC_DEBUG CHATOMIC_DEBUG[512];
} CSL_DRU_CHATOMIC_DEBUGRegs;


/**************************************************************************
* Register Macros
**************************************************************************/

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1(CHATOMIC_DEBUG) (0x00000000U+((CHATOMIC_DEBUG)*0x100U))
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3(CHATOMIC_DEBUG) (0x00000008U+((CHATOMIC_DEBUG)*0x100U))
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5(CHATOMIC_DEBUG) (0x00000010U+((CHATOMIC_DEBUG)*0x100U))
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7(CHATOMIC_DEBUG) (0x00000018U+((CHATOMIC_DEBUG)*0x100U))
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9(CHATOMIC_DEBUG) (0x00000020U+((CHATOMIC_DEBUG)*0x100U))
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11(CHATOMIC_DEBUG) (0x00000028U+((CHATOMIC_DEBUG)*0x100U))
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13(CHATOMIC_DEBUG) (0x00000030U+((CHATOMIC_DEBUG)*0x100U))
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15(CHATOMIC_DEBUG) (0x00000038U+((CHATOMIC_DEBUG)*0x100U))
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1(CHATOMIC_DEBUG, DEBUG) (0x00000040U+((CHATOMIC_DEBUG)*0x100U)+((DEBUG)*0x40U))
#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3(CHATOMIC_DEBUG, DEBUG) (0x00000048U+((CHATOMIC_DEBUG)*0x100U)+((DEBUG)*0x40U))
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5(CHATOMIC_DEBUG, DEBUG) (0x00000050U+((CHATOMIC_DEBUG)*0x100U)+((DEBUG)*0x40U))
#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7(CHATOMIC_DEBUG, DEBUG) (0x00000058U+((CHATOMIC_DEBUG)*0x100U)+((DEBUG)*0x40U))
#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9(CHATOMIC_DEBUG, DEBUG) (0x00000060U+((CHATOMIC_DEBUG)*0x100U)+((DEBUG)*0x40U))
#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11(CHATOMIC_DEBUG, DEBUG) (0x00000068U+((CHATOMIC_DEBUG)*0x100U)+((DEBUG)*0x40U))
#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13(CHATOMIC_DEBUG, DEBUG) (0x00000070U+((CHATOMIC_DEBUG)*0x100U)+((DEBUG)*0x40U))
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15(CHATOMIC_DEBUG, DEBUG) (0x00000078U+((CHATOMIC_DEBUG)*0x100U)+((DEBUG)*0x40U))

/**************************************************************************
* Field Definition Macros
**************************************************************************/


/* NEXT_TR_WORD0_1 */

#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_FLAGS_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_FLAGS_SHIFT (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_FLAGS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_FLAGS_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_ICNT0_MASK (0x0000FFFF00000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_ICNT0_SHIFT (0x0000000000000020U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_ICNT0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_ICNT0_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_ICNT1_MASK (0xFFFF000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_ICNT1_SHIFT (0x0000000000000030U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_ICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_ICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD0_1_RESETVAL (0x0000000000000000U)

/* NEXT_TR_WORD2_3 */

#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_RSVD_MASK (0xFFFF000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_RSVD_SHIFT (0x0000000000000030U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_RSVD_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_SRC_ADDR_MASK (0x0000FFFFFFFFFFFFU)
#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_SRC_ADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_SRC_ADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_SRC_ADDR_MAX (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD2_3_RESETVAL (0x0000000000000000U)

/* NEXT_TR_WORD4_5 */

#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_DIM1_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_DIM1_SHIFT (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_DIM1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_DIM1_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_ICNT2_MASK (0x0000FFFF00000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_ICNT2_SHIFT (0x0000000000000020U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_ICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_ICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_ICNT3_MASK (0xFFFF000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_ICNT3_SHIFT (0x0000000000000030U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_ICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_ICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD4_5_RESETVAL (0x0000000000000000U)

/* NEXT_TR_WORD6_7 */

#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_DIM2_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_DIM2_SHIFT (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_DIM2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_DIM2_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_DIM3_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_DIM3_SHIFT (0x0000000000000020U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_DIM3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_DIM3_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD6_7_RESETVAL (0x0000000000000000U)

/* NEXT_TR_WORD8_9 */

#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_DDIM1_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_DDIM1_SHIFT (0x0000000000000020U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_DDIM1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_DDIM1_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_FMTFLAGS_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_FMTFLAGS_SHIFT (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_FMTFLAGS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_FMTFLAGS_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD8_9_RESETVAL (0x0000000000000000U)

/* NEXT_TR_WORD10_11 */

#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_DADDR_MASK (0x0000FFFFFFFFFFFFU)
#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_DADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_DADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_DADDR_MAX (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_RSVD_MASK (0xFFFF000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_RSVD_SHIFT (0x0000000000000030U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_RSVD_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD10_11_RESETVAL (0x0000000000000000U)

/* NEXT_TR_WORD12_13 */

#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_DDIM2_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_DDIM2_SHIFT (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_DDIM2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_DDIM2_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_DDIM3_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_DDIM3_SHIFT (0x0000000000000020U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_DDIM3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_DDIM3_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD12_13_RESETVAL (0x0000000000000000U)

/* NEXT_TR_WORD14_15 */

#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT0_MASK (0x000000000000FFFFU)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT0_SHIFT (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT0_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT1_MASK (0x00000000FFFF0000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT1_SHIFT (0x0000000000000010U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT2_MASK (0x0000FFFF00000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT2_SHIFT (0x0000000000000020U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT3_MASK (0xFFFF000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT3_SHIFT (0x0000000000000030U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_DICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_DEBUG_NEXT_TR_WORD14_15_RESETVAL (0x0000000000000000U)

/* ATOMIC_SUBMIT_CURR_TR_WORD0_1 */

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_FLAGS_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_FLAGS_SHIFT (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_FLAGS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_FLAGS_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_ICNT0_MASK (0x0000FFFF00000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_ICNT0_SHIFT (0x0000000000000020U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_ICNT0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_ICNT0_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_ICNT1_MASK (0xFFFF000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_ICNT1_SHIFT (0x0000000000000030U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_ICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_ICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD0_1_RESETVAL (0x0000000000000000U)

/* ATOMIC_SUBMIT_CURR_TR_WORD2_3 */

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_RSVD_MASK (0xFFFF000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_RSVD_SHIFT (0x0000000000000030U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_RSVD_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_SRC_ADDR_MASK (0x0000FFFFFFFFFFFFU)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_SRC_ADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_SRC_ADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_SRC_ADDR_MAX (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD2_3_RESETVAL (0x0000000000000000U)

/* ATOMIC_SUBMIT_CURR_TR_WORD4_5 */

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_DIM1_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_DIM1_SHIFT (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_DIM1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_DIM1_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_ICNT2_MASK (0x0000FFFF00000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_ICNT2_SHIFT (0x0000000000000020U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_ICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_ICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_ICNT3_MASK (0xFFFF000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_ICNT3_SHIFT (0x0000000000000030U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_ICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_ICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD4_5_RESETVAL (0x0000000000000000U)

/* ATOMIC_SUBMIT_CURR_TR_WORD6_7 */

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_DIM2_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_DIM2_SHIFT (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_DIM2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_DIM2_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_DIM3_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_DIM3_SHIFT (0x0000000000000020U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_DIM3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_DIM3_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD6_7_RESETVAL (0x0000000000000000U)

/* ATOMIC_SUBMIT_CURR_TR_WORD8_9 */

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_DDIM1_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_DDIM1_SHIFT (0x0000000000000020U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_DDIM1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_DDIM1_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_FMTFLAGS_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_FMTFLAGS_SHIFT (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_FMTFLAGS_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_FMTFLAGS_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD8_9_RESETVAL (0x0000000000000000U)

/* ATOMIC_SUBMIT_CURR_TR_WORD10_11 */

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_DADDR_MASK (0x0000FFFFFFFFFFFFU)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_DADDR_SHIFT (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_DADDR_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_DADDR_MAX (0x0000FFFFFFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_RSVD_MASK (0xFFFF000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_RSVD_SHIFT (0x0000000000000030U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_RSVD_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_RSVD_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD10_11_RESETVAL (0x0000000000000000U)

/* ATOMIC_SUBMIT_CURR_TR_WORD12_13 */

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_DDIM2_MASK (0x00000000FFFFFFFFU)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_DDIM2_SHIFT (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_DDIM2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_DDIM2_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_DDIM3_MASK (0xFFFFFFFF00000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_DDIM3_SHIFT (0x0000000000000020U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_DDIM3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_DDIM3_MAX (0x00000000FFFFFFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD12_13_RESETVAL (0x0000000000000000U)

/* ATOMIC_SUBMIT_CURR_TR_WORD14_15 */

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT0_MASK (0x000000000000FFFFU)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT0_SHIFT (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT0_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT0_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT1_MASK (0x00000000FFFF0000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT1_SHIFT (0x0000000000000010U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT1_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT1_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT2_MASK (0x0000FFFF00000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT2_SHIFT (0x0000000000000020U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT2_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT2_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT3_MASK (0xFFFF000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT3_SHIFT (0x0000000000000030U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT3_RESETVAL (0x0000000000000000U)
#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_DICNT3_MAX (0x000000000000FFFFU)

#define CSL_DRU_ATOMIC_SUBMIT_CURR_TR_WORD14_15_RESETVAL (0x0000000000000000U)

/**************************************************************************
 *  DRU TOP LEVEL Struct (hand created DLB)
 *************************************************************************/

typedef struct {
    CSL_DRU_Regs                                DRURegs;
    uint8_t                                     RSVD01[16368];
    CSL_DRU_SAFETYRegs                          DRUSafety;
    uint8_t                                     RSVD02[12280];
    CSL_DRU_QUEUERegs                           DRUQueues;
    uint8_t                                     RSVD03[32640];
    CSL_DRU_MEM_ATT0Regs                        DRUAtt0;
    uint8_t                                     RSVD04[32768];
    CSL_DRU_MEM_ATT1Regs                        DRUAtt1;
    uint8_t                                     RSVD05[32768];
    CSL_DRU_MEM_ATT2Regs                        DRUAtt2;
    uint8_t                                     RSVD06[32768];
    CSL_DRU_CHNRTRegs_CHNRT                     CHNRT[512];
    CSL_DRU_CHRTRegs_CHRT                       CHRT[512];
    CSL_DRU_CHATOMIC_DEBUGRegs_CHATOMIC_DEBUG   CHATOMIC[512];
    CSL_DRU_CHCORERegs_CHCORE                   CHCORE[512];
    CSL_DRU_CHCORE_HI                           CHCOREHI[512];
    CSL_DRU_CAUSE                               CAUSE;
} CSL_DRU_t;
#ifdef __cplusplus
}
#endif
#endif
